//
// Automatically generated by the IPDL compiler.
// Edit at your own risk
//

#ifndef PBrowserStream_h
#define PBrowserStream_h

#include "base/basictypes.h"
#include "prtime.h"
#include "nscore.h"
#include "IPCMessageStart.h"
#include "IPC/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "nsIFile.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/plugins/PluginMessageUtils.h"

//-----------------------------------------------------------------------------
// Code common to PBrowserStreamChild and PBrowserStreamParent
//
namespace mozilla {
namespace plugins {
namespace PBrowserStream {

enum State {
    StateStart = 0,
    StateError,
    StateLast
};

enum MessageType {
    PBrowserStreamStart = PBrowserStreamMsgStart << 10,
    PBrowserStreamPreStart = (PBrowserStreamMsgStart << 10) - 1,
    Msg_Write__ID,
    Msg_NPP_StreamAsFile__ID,
    Reply_NPP_StreamAsFile__ID,
    Msg_NPP_DestroyStream__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_NPN_RequestRead__ID,
    Reply_NPN_RequestRead__ID,
    Msg_NPN_DestroyStream__ID,
    Msg_StreamDestroyed__ID,
    PBrowserStreamEnd
};

class Msg_Write :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;
    typedef mozilla::plugins::IPCByteRanges IPCByteRanges;

public:
    enum {
        ID = Msg_Write__ID
    };
    Msg_Write(
            const int32_t& offset,
            const Buffer& data,
            const uint32_t& newlength) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PBrowserStream::Msg_Write")
    {
        IPC::WriteParam(this, offset);
        IPC::WriteParam(this, data);
        IPC::WriteParam(this, newlength);
    }

    static bool
    Read(
            const Message* msg,
            int32_t* offset,
            Buffer* data,
            uint32_t* newlength)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), offset)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), data)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), newlength)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Write(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPP_StreamAsFile :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;
    typedef mozilla::plugins::IPCByteRanges IPCByteRanges;

public:
    enum {
        ID = Msg_NPP_StreamAsFile__ID
    };
    Msg_NPP_StreamAsFile(const nsCString& fname) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PBrowserStream::Msg_NPP_StreamAsFile")
    {
        IPC::WriteParam(this, fname);
    }

    static bool
    Read(
            const Message* msg,
            nsCString* fname)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), fname)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPP_StreamAsFile(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPP_StreamAsFile :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;
    typedef mozilla::plugins::IPCByteRanges IPCByteRanges;

public:
    enum {
        ID = Reply_NPP_StreamAsFile__ID
    };
    Reply_NPP_StreamAsFile() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PBrowserStream::Reply_NPP_StreamAsFile")
    {
    }

    static bool
    Read(const Message* msg)
    {
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPP_StreamAsFile(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPP_DestroyStream :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;
    typedef mozilla::plugins::IPCByteRanges IPCByteRanges;

public:
    enum {
        ID = Msg_NPP_DestroyStream__ID
    };
    Msg_NPP_DestroyStream(const NPReason& reason) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PBrowserStream::Msg_NPP_DestroyStream")
    {
        IPC::WriteParam(this, reason);
    }

    static bool
    Read(
            const Message* msg,
            NPReason* reason)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), reason)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPP_DestroyStream(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;
    typedef mozilla::plugins::IPCByteRanges IPCByteRanges;

public:
    enum {
        ID = Msg___delete____ID
    };
    Msg___delete__(const ActorHandle& actor) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PBrowserStream::Msg___delete__")
    {
        IPC::WriteParam(this, actor);
    }

    static bool
    Read(
            const Message* msg,
            ActorHandle* actor)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), actor)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg___delete__(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;
    typedef mozilla::plugins::IPCByteRanges IPCByteRanges;

public:
    enum {
        ID = Reply___delete____ID
    };
    Reply___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PBrowserStream::Reply___delete__")
    {
    }

    static bool
    Read(const Message* msg)
    {
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply___delete__(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_RequestRead :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;
    typedef mozilla::plugins::IPCByteRanges IPCByteRanges;

public:
    enum {
        ID = Msg_NPN_RequestRead__ID
    };
    Msg_NPN_RequestRead(const IPCByteRanges& ranges) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PBrowserStream::Msg_NPN_RequestRead")
    {
        IPC::WriteParam(this, ranges);
    }

    static bool
    Read(
            const Message* msg,
            IPCByteRanges* ranges)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), ranges)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_RequestRead(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_RequestRead :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;
    typedef mozilla::plugins::IPCByteRanges IPCByteRanges;

public:
    enum {
        ID = Reply_NPN_RequestRead__ID
    };
    Reply_NPN_RequestRead(const NPError& result) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PBrowserStream::Reply_NPN_RequestRead")
    {
        IPC::WriteParam(this, result);
    }

    static bool
    Read(
            const Message* msg,
            NPError* result)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), result)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_RequestRead(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_DestroyStream :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;
    typedef mozilla::plugins::IPCByteRanges IPCByteRanges;

public:
    enum {
        ID = Msg_NPN_DestroyStream__ID
    };
    Msg_NPN_DestroyStream(const NPReason& reason) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PBrowserStream::Msg_NPN_DestroyStream")
    {
        IPC::WriteParam(this, reason);
    }

    static bool
    Read(
            const Message* msg,
            NPReason* reason)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), reason)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_DestroyStream(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_StreamDestroyed :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;
    typedef mozilla::plugins::IPCByteRanges IPCByteRanges;

public:
    enum {
        ID = Msg_StreamDestroyed__ID
    };
    Msg_StreamDestroyed() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PBrowserStream::Msg_StreamDestroyed")
    {
    }

    static bool
    Read(const Message* msg)
    {
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_StreamDestroyed(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};



} // namespace PBrowserStream
} // namespace plugins
} // namespace mozilla

#endif // ifndef PBrowserStream_h
